SYSTEM_CONFIG_OPERATION_INIT_OFF = 0x00
SYSTEM_CONFIG_OPERATION_INIT_ON = 0x01
SYSTEM_CONFIG_OPERATION_INIT_LAST = 0x02
SYSTEM_CONFIG_CAN_CTRL_SVR = 0x00
SYSTEM_CONFIG_CAN_CTRL_CAN = 0x01

BIDIRECTIONAL_CONFIG_MODE_CV = 0x00
BIDIRECTIONAL_CONFIG_MODE_BATTERY = 0x01

DIRECTION_CTRL_CHARGE = 0x00
DIRECTION_CTRL_DISCHARGE = 0x01

OPERATION = (0x0000, "rw", 1)
VOUT_SET = (0x0020, "rw", 2)
IOUT_SET = (0x0030, "rw", 2)
FAULT_STATUS = (0x0040, "r", 2)
READ_VIN = (0x0050, "r", 2)
READ_VOUT = (0x0060, "r", 2)
READ_IOUT = (0x0061, "r", 2)
READ_TEMPERATURE = (0x0062, "r", 2)
MFR_ID_B0B5 = (0x0080, "r", 6)
MFR_ID_B6B11 = (0x0081, "r", 6)
MFR_MODEL_B0B5 = (0x0082, "r", 6)
MFR_MODEL_B6B11 = (0x0083, "r", 6)
MFR_REVISION_B0B5 = (0x0084, "r", 6)
MFR_LOCATION_B0B2 = (0x0085, "rw", 3)
MFR_DATE_B0B5 = (0x0086, "rw", 6)
MFR_SERIAL_B0B5 = (0x0087, "rw", 6)
MFR_SERIAL_B6B11 = (0x0088, "rw", 6)
SCALING_FACTOR = (0x00C0, "r", 2)
SYSTEM_STATUS = (0x00C1, "r", 2)
SYSTEM_CONFIG = (0x00C2, "rw", 2)
DIRECTION_CTRL = (0x0100, "rw", 1)
REVERSE_VOUT_SET = (0x0120, "rw", 2)
REVERSE_IOUT_SET = (0x0130, "rw", 2)
BIDIRECTIONAL_CONFIG = (0x0140, "rw", 2)

CMD_LOOKUP_TABLE = {
    0x0000: OPERATION,
    0x0020: VOUT_SET,
    0x0030: IOUT_SET,
    0x0040: FAULT_STATUS,
    0x0050: READ_VIN,
    0x0060: READ_VOUT,
    0x0061: READ_IOUT,
    0x0062: READ_TEMPERATURE,
    0x0080: MFR_ID_B0B5,
    0x0081: MFR_ID_B6B11,
    0x0082: MFR_MODEL_B0B5,
    0x0083: MFR_MODEL_B6B11,
    0x0084: MFR_REVISION_B0B5,
    0x0085: MFR_LOCATION_B0B2,
    0x0086: MFR_DATE_B0B5,
    0x0087: MFR_SERIAL_B0B5,
    0x0088: MFR_SERIAL_B6B11,
    0x00C0: SCALING_FACTOR,
    0x00C1: SYSTEM_STATUS,
    0x00C2: SYSTEM_CONFIG,
    0x0100: DIRECTION_CTRL,
    0x0120: REVERSE_VOUT_SET,
    0x0130: REVERSE_IOUT_SET,
    0x0140: BIDIRECTIONAL_CONFIG,
}
